//+------------------------------------------------------------------+
//|                                                    DOSR_Dots.mq4 |
//|                                                          Kalenzo |
//|                                          http://www.fxservice.eu |
//+------------------------------------------------------------------+
//mod InnOutBar mtf
#property copyright "Kalenzo"
#property link      "http://www.fxservice.eu"
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Magenta
#property indicator_color2 MediumVioletRed
#property indicator_color3 DodgerBlue
#property indicator_color4 RoyalBlue
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2


double val1[];
double val2[];
double val3[];
double val4[];
double trend[];

extern int  tf              = 60;
extern bool alertsOn        = true;
extern bool alertsOnCurrent = false;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
   SetIndexBuffer(2,val3);
   SetIndexBuffer(3,val4);
   SetIndexBuffer(4,trend);
  
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
   
   SetIndexArrow(0,158);
   SetIndexArrow(1,158);
   SetIndexArrow(2,158);   
   SetIndexArrow(3,158);   
   
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   SetIndexEmptyValue(2,EMPTY_VALUE);
   SetIndexEmptyValue(3,EMPTY_VALUE);
   
   SetIndexLabel(0,"in hi");
   SetIndexLabel(1,"in lo");
   SetIndexLabel(2,"out hi");
   SetIndexLabel(3,"out lo");

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
      int limit;
      int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
      limit=MathMin(Bars-counted_bars+2*(tf/Period()),Bars-1);
  
      for(int i=limit; i>=0; i--)
      {
         int bs = iBarShift(Symbol(),tf,Time[i]);
         
         double H1 = iHigh(Symbol(),tf,bs+1);
         double L1 = iLow(Symbol(),tf,bs+1);
         
         double H = iHigh(Symbol(),tf,bs);
         double L = iLow(Symbol(),tf,bs);
        
         val1[i] = EMPTY_VALUE;
         val2[i] = EMPTY_VALUE;
         val3[i] = EMPTY_VALUE;
         val4[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
             if ((H1>H)&&(L1<L)) { trend[i] =  1; val1[i] = H; val2[i] = L; }
             if ((H1<H)&&(L1>L)) { trend[i] = -1; val3[i] = H; val4[i] = L; }  
    
      }
    manageAlerts();       
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,tf,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]== 1) doAlert(whichBar,"Inside Bar");
         if (trend[whichBar]==-1) doAlert(whichBar,"Outside Bar");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Inside OutBar ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Inside OutBar "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}